#!/usr/bin/perl -w -I/usr/sausalito/perl/

use strict;

use CCE;

use Sauce::Util;
use Sauce::Config;
use Sauce::Validators qw(hostname username password alters);

my $cce = new CCE( Namespace => 'Multidrop',
                   Domain    => 'base-multidrop' );

$cce->connectfd();

# Globals.

my $Fetchmailrc_dir = "/etc/fetchmail";
my $Fetchmailrc_conf = $Fetchmailrc_dir . "/multidrop:localdomain";
my $chkconfig = "/sbin/chkconfig";
my $scriptName = "fetchmail";
my $scriptLoc = "/etc/rc.d/init.d/fetchmail";


my $obj = $cce->event_object();

if($obj->{interval} < 1){
	$cce->warn("[[base-multidrop.badInterval]]");
	$cce->bye("FAIL");
}

# do this here or we lose the password, if they don't re-enter it
# and enable multidrop later
umask(0176); #for fetchmailrc file
Sauce::Util::replaceblock($Fetchmailrc_conf,
	'# Start Cobalt Multidrop Domain',
	&set_domain_rc(),
	'# End Cobalt Multidrop Domain') || finish($cce);

if($obj->{enable}){
	system($chkconfig ,'--add', $scriptName);
	system("$scriptLoc restart > /dev/null 2>&1");
}else{
	system($chkconfig,'--del', $scriptName);
	system("$scriptLoc stop > /dev/null 2>&1");
}

$cce->bye("SUCCESS");

exit(0);

sub finish
{
	my $cce = shift;
	$cce->warn("failure");
	$cce->bye("FAIL");
	exit 1;
}


sub set_domain_rc
{
	my $ret="";
	my $interval=$obj->{interval}*60; #minutes to seconds
	my $pass="";
	#produces server-specific (well...mostly)
	#fetchmail conf stuff.

	if(-e $Fetchmailrc_conf){
		open(RC,$Fetchmailrc_conf);
		my @rc=<RC>;
		close RC;
		(grep {/with pass/} @rc)[0] =~ /pass "([^\s]+)"/;
		$pass=$1;
	}
	
	$pass=$obj->{password} || $pass;

	$ret="set daemon $interval\n";
	$ret.="poll $obj->{server} aka $obj->{userDomain} proto $obj->{proto}:\n";
	$ret.="user $obj->{userName} with pass \"$pass\" to * here\n";

	return $ret;
}

